'******************************************************
'*  FIXPARMS.BAS         (c) bob muchamore            *
'*  ver 1.1.01           for the "FREECEN" Project    *
'*  March 2002                                        *
'******************************************************
'1.1.0 29Mar2002 altered to accept changeable drive IDs
'                <Esc> to Quit added
'1.1.01 03Apr2002 <Esc> taken out again!


DECLARE SUB clearlower (row%, depth%)
DECLARE SUB drivenames ()
DECLARE SUB fix2 ()
DECLARE SUB fix3 ()
DECLARE SUB gosee ()
DECLARE SUB introp ()
DECLARE SUB warning ()

DIM SHARED choice$, fdrv$, hdrv$, filname$, lookat$, piece$, version$

ON ERROR GOTO Errortrap
version$ = "1.1.01"

CLS

LOCATE 1, 1, , 4, 7
COLOR 7, 1
introp
IF choice$ = "Q" THEN GOTO alldone
fix2
IF choice$ = "Q" THEN GOTO alldone
fix3

alldone:
CHAIN "fctmenu"
END

Errortrap:

IF ERR = 53 AND ERL = 410 THEN
   COLOR 12: PRINT : PRINT "     No ctyPARMS.DAT file found": COLOR 7:
   PRINT "     FIXPARMS is unable to continue"
   PRINT "          any key to return to Menu": any$ = INPUT$(1)
   GOTO alldone
END IF

IF ERR = 53 AND ERL = 420 THEN
   COLOR 12: PRINT : PRINT "     No Error File found": COLOR 7:
   PRINT "     FIXPARMS is unable to continue"
   PRINT "          any key to return to Menu": any$ = INPUT$(1)
   GOTO alldone
END IF

IF ERR = 53 AND ERL = 440 THEN
   COLOR 12: PRINT : PRINT "     "; filname$; " NOT found": COLOR 7:
   PRINT "     FIXPARMS is unable to continue"
   PRINT "          any key to return to Menu": any$ = INPUT$(1)
   GOTO alldone
END IF

SUB clearlower (row%, depth%)

clean$ = STRING$(79, " ")

FOR I = 0 TO depth%
   LOCATE row% + I, 1: PRINT clean$
NEXT I

END SUB

SUB drivenames

OPEN "drives.dat" FOR INPUT AS #1
INPUT #1, hdrv$: INPUT #1, fdrv$
CLOSE #1

END SUB

SUB fix2

CLS
COLOR 14: LOCATE 2, 20: PRINT "FIXPARMS is required ONLY for Transcriber files."
COLOR 7: LOCATE 4, 10
PRINT "A suitable "; STRING$(3, 176); "PARMS.DAT file must be in folder "; hdrv$; ":\fctools\fctwkg\"
LOCATE 5, 20: PRINT "Opportunity exists to change, or to establish, "
LOCATE 6, 10
PRINT "the FREECENS "; CHR$(34); "CODE"; CHR$(34); " and Name for the Transcriber of the Census Data."
LOCATE 8, 10: PRINT "You will be asked for a Piece Number."
COLOR 14: LOCATE 9, 10
PRINT " CHECK the displayed Household Count and Records Count"
COLOR 7: LOCATE 10, 10
PRINT "The REQUIRED values can be determined from a CSV2DAT Error Report"
LOCATE 12, 10: PRINT "Amend either value as necessary."
LOCATE 13, 10: PRINT "The Civil Parish may be named, and an instruction ";
COLOR 10: PRINT "Enter Y to ...": COLOR 7
LOCATE 14, 10
PRINT "The cycle will be repeated until you <return> with no Piece No."

COLOR 14: LOCATE 18, 10: PRINT "Q to Quit; or any other key to continue "
choice$ = UCASE$(INPUT$(1)): COLOR 7
IF choice$ <> "Q" THEN choice$ = "C"

END SUB

SUB fix3

refix:
CLS
look$ = ".\fctwkg\???PARMS.DAT"
410 LOCATE 1, 1: FILES look$
c% = CSRLIN
COLOR 14: LOCATE 1, 15: PRINT "Files available for edit: "
COLOR 7
LOCATE c% - 1, 1: PRINT SPACE$(79)

PRINT : COLOR 14: PRINT "          Enter filename to edit "; : INPUT "", filname$
COLOR 7
IF filname$ = "" THEN EXIT SUB
filname$ = ".\fctwkg\" + MID$(filname$, 1, 8) + ".DAT"
440 OPEN "I", #1, filname$: CLOSE #1

PRINT : COLOR 14: PRINT "          Enter PIECE Name (eg. RGyynnnn) "; : INPUT "", piece$
COLOR 7
piece$ = MID$(piece$, 1, 8)

PRINT : COLOR 14: PRINT "          Do you need household and record numbers from rebuilt file?"
COLOR 7
PRINT "          type Y if Yes; any other key to continue": choice$ = UCASE$(INPUT$(1))

SELECT CASE choice$
   CASE "Y"
      gosee
      COLOR 14:  PRINT "          Jot down the Records and Household Numbers"
   CASE ELSE
END SELECT

PRINT "          Q to Quit; any other key to continue"
any$ = UCASE$(INPUT$(1))
COLOR 7
IF any$ = "Q" THEN EXIT SUB

CLS
fixit$ = "fixparms " + filname$
SHELL fixit$

PRINT : COLOR 14: PRINT "CHECK: are all necessary changes made?"
PRINT "Type Y if correct; any other key to RE-RUN";
COLOR 7
any$ = UCASE$(INPUT$(1))
IF any$ <> "Y" THEN GOTO refix

END SUB

SUB gosee

look$ = hdrv$ + ":\fctools\fctwkg\" + piece$ + ".erc"
420 OPEN "I", #1, look$: CLOSE #1

lookat$ = "type " + look$
SHELL lookat$

END SUB

SUB introp

warning
drivenames

COLOR 14: LOCATE 3, 30: PRINT "   F I X P A R M S"
LOCATE 3, 65: PRINT version$
LOCATE 10, 10: PRINT "FUNCTION:"
COLOR 7: LOCATE 11, 10: PRINT "The file "; : COLOR 10: PRINT "ctyPARMS.DAT ";
COLOR 7: PRINT "holds a count of the numbers of Households and"
LOCATE 12, 10: PRINT "Records contained within a Transcription File ";
COLOR 10: PRINT "(RGyypppp.DAT)."
COLOR 7: LOCATE 13, 10: PRINT "It is therefore vital that these two files are correctly aligned"
LOCATE 14, 10: PRINT "or INCENS will attempt to write new work to a "; CHR$(34); "wrong"; CHR$(34); " file location."

LOCATE 16, 10: PRINT "Rebuilding of ctyPARMS.DAT is very necessary if the file itself has"
LOCATE 17, 10: PRINT "become corrupt, or if RGyypppp.DAT has been rebuilt and Data Entry "
LOCATE 18, 10: PRINT "has not been completed for the whole Piece."
LOCATE 20, 10: PRINT "After conversion from SS-CENS Data Entry it is desireable that the"
LOCATE 21, 10: PRINT "Code and Name of the Transcriber should be recorded in ctyPARMS."

LOCATE 23, 20: PRINT "Q to QUIT; or any other key to Continue ";
choice$ = UCASE$(INPUT$(1))
IF choice$ = CHR$(3) THEN STOP
IF choice$ <> "Q" THEN choice$ = "C"

END SUB

SUB warning

COLOR 12
LOCATE 6, 10: PRINT " WARNING: Always work on copies of your data files with these "
LOCATE 7, 10: PRINT " programmes and keep copies of the originals safe.            "
LOCATE 8, 10: PRINT " We do not wish to hazard many hours of painstaking work.     "


END SUB

