'******************************************************
'*  QCHK.BAS             (c) bob muchamore            *
'*  ver 1.2.02            for the "FREECEN" Project   *
'*  13 June 2002                                      *
'******************************************************
'1.1.0 29Mar2002 altered to allow changeable drive IDs
'1.1.01 03Apr2002 \wkg changed to \tmp
'1.2.0  09Jun2002 add sub fixfilename to work 8+3 format filenames
'1.2.01  13Jun2002 Remove debugging "STOP" inadvertently left in last time
'1.2.02 24Jan2004 Scotland added

DECLARE SUB clearlower (row%, depth%)
DECLARE SUB drivenames ()
DECLARE SUB fixfilename ()
DECLARE SUB qchk1 ()
DECLARE SUB qchk2 ()
DECLARE SUB readerrorfile ()
DECLARE SUB Warning ()

DIM SHARED chk$, choice, choice$, param1$, drv$, fdrv$, hdrv$, fil$, fil8$
DIM SHARED look$, lookin2$, ok$, filnam1$, filnam2$, filnam3$, c2dcom$
DIM SHARED findit$, unpik$, noread, looksee$, version$

ON ERROR GOTO errortrap
version$ = "1.2.0"
CLS
LOCATE 1, 1, , 4, 7: '**** set deep cursor
COLOR 7, 1
COLOR 14
qchk1
IF choice$ <> "C" THEN GOTO alldone
qchk2

unpik$ = "pkunzip " + chk$ + " \fctools\tmp"
SHELL unpik$

CLS
120 PRINT : FILES "\fctools\tmp\*.che"
GOTO pickfile: '**** ONLY if .CHE file found
130 PRINT : FILES "\fctools\tmp\*.dat"

pickfile:
c% = CSRLIN: LOCATE c% - 1, 1: PRINT SPACE$(79)
140 COLOR 7: PRINT "Enter the filename to be tested (include EXTension) "; : COLOR 14: INPUT "", fil$: COLOR 7
fil$ = UCASE$(fil$)
IF fil$ = "" OR fil$ = "Q" THEN GOTO alldone

test1$ = "\fctools\tmp\" + fil$
150 OPEN "I", #1, test1$: CLOSE #1: '**** check file exists
test2$ = "dat2csv -a -q " + test1$
SHELL test2$

fixfilename

test$ = fil8$
test1$ = "\fctools\tmp\" + fil8$
MID$(test$, 10, 3) = "ERD": erfila$ = fdrv$ + ":\" + test$
hold1$ = MID$(test1$, 1, 22) + "ERD"
emit$ = "copy " + hold1$ + " " + erfila$
SHELL emit$

test3$ = MID$(hold1$, 1, 22) + "CSV"
test2$ = "csv2dat -a -q " + test3$
SHELL test2$

PRINT
hold1$ = MID$(test1$, 1, 22) + "ERC"
MID$(test$, 10, 3) = "ERC": erfilb$ = fdrv$ + ":\" + test$
emit$ = "copy " + hold1$ + " " + erfilb$
SHELL emit$

COLOR 12: PRINT "CHECK ABOVE FOR ANY ERRORS REPORTED ";
COLOR 7: PRINT "... Hit any key to continue": any$ = INPUT$(1)
clean$ = "\fctools\tmp\*.*": KILL clean$

readerrorfile
IF noread = 1 THEN GOTO alldone
CLS
read1$ = "type " + erfila$ + " |more"
SHELL read1$
PRINT " any key to continue": any$ = INPUT$(1)

read2$ = "type " + erfilb$ + " |more"
SHELL read2$
PRINT " any key to continue": any$ = INPUT$(1)
CLS
alldone:

CLOSE
PRINT : PRINT : COLOR 12: PRINT "END OF RUN: Remove any floppy disk to safety": COLOR 7
PRINT : PRINT "                 any key to continue"; any$ = INPUT$(1):

CHAIN "fctmenu"

END

errortrap:
'**** failure to find .ZIP file on floppy:\
IF (ERR = 53 OR ERR = 75) AND ERL = 110 THEN
   COLOR 12: PRINT "That file not found.  Hit any key to select again": any$ = INPUT$(1)
   COLOR 7
   RUN
END IF

'**** line 120 has failed to find .CHE file
IF ERR = 53 AND ERL = 120 THEN RESUME 130

'**** and line 130 has failed to find .DAT either!
IF ERR = 53 AND ERL = 130 THEN
   CLS
   COLOR 12
   PRINT : PRINT " No files ending .CHE nor .DAT are contained in this zip-file"
   COLOR 7: PRINT : PRINT "             Hit any key to continue": any$ = INPUT$(1)
   RUN
END IF

'**** incorrect entry of a filename (file not found)
IF ERR = 53 AND ERL = 150 THEN
   COLOR 12: PRINT " Error! - do again": COLOR 7
   RESUME 140
END IF

'**** D2C2D failure, wrong filename to what was expected
IF ERR = 5 AND ERL = 150 THEN
' 1.2.02 Scotland added
   PRINT "D2C2D requires filename to begin RG or HO (RS or HS for Scotland)"
   RESUME 140
END IF

'**** misc failure to find filename
IF ERR = 53 THEN
   PRINT "No suitable file found. Run Aborted"
   PRINT : PRINT "Please check for correct floppy disk and restart"
   PRINT "                Hit any key to continue": any$ = INPUT$(1)
   GOTO alldone
END IF

'**** no disk in floppy:\
IF ERR = 68 THEN
   PRINT "Drive "; fdrv$; ":\ not ready. Run Aborted"
   PRINT : PRINT "Please check for correct floppy disk and restart"
   PRINT "                Hit any key to continue": any$ = INPUT$(1)
   GOTO alldone
END IF

PRINT ERR, ERL

SUB clearlower (row%, depth%)

clean$ = STRING$(78, " ")

FOR i = 0 TO depth%
   LOCATE row% + i, 1: PRINT clean$
NEXT i

END SUB

SUB drivenames

OPEN "drives.dat" FOR INPUT AS #1
INPUT #1, hdrv$: INPUT #1, fdrv$
CLOSE #1

END SUB

SUB fixfilename

fil8$ = fil$
DO UNTIL LEN(fil8$) = 12
   fil8$ = LEFT$(fil8$, 4) + "0" + MID$(fil8$, 5)
LOOP

END SUB

SUB qchk1

CLS
SCREEN 0, 8
COLOR 14
FOR i = 0 TO 2
   LOCATE 2 + i, 30: PRINT SPACE$(19)
NEXT i

Warning
drivenames

COLOR 14: LOCATE 3, 30: PRINT "      Q C H K   "
LOCATE 3, 65: PRINT version$
COLOR 14: LOCATE 12, 10: PRINT " FUNCTION:": COLOR 7
LOCATE 13, 10: PRINT " QCHK will perform a rapid test on any zipped FREECEN file to "
LOCATE 14, 10: PRINT " detect the presence of Serious Errors which could interfere"
LOCATE 15, 10: PRINT " with subsequent FREECEN operations.  "
LOCATE 16, 10: PRINT " A File report is produced and may be examined to determine  "
LOCATE 17, 10: PRINT " whether the file requires correction before being passed to"
LOCATE 18, 10: PRINT " further FREECEN processing. "
LOCATE 20, 10: PRINT " QCHK can be used with any Transcription, Checked or Validated files"
COLOR 10: LOCATE 21, 15: PRINT " ... and requires no special skills."

COLOR 14: LOCATE 23, 10: PRINT " Select Q to Quit; any other key to Continue "
LOCATE 23, 69: choice$ = UCASE$(INPUT$(1))


IF choice$ = CHR$(3) THEN STOP
IF choice$ <> "Q" THEN choice$ = "C"

END SUB

SUB qchk2

ON ERROR GOTO errortrap

CLS
COLOR 14:
LOCATE 2, 15: PRINT "You will need a FREECEN zipped disk in Floppy Drive A:"
COLOR 7: LOCATE 3, 10: PRINT "Please leave the disk in the drive until the routine has finished"

LOCATE 5, 15: PRINT " Hit any key to continue"; any$ = INPUT$(1)
LOCATE 5, 1: PRINT SPACE$(40): LOCATE 5, 1
looksee$ = fdrv$ + ":\*.ZIP"
277 FILES looksee$
c% = CSRLIN
LOCATE c% - 1, 1: PRINT SPACE$(79)

badtry:
LOCATE c%, 15: PRINT "Type the filename to be checked (include .ZIP) "; : COLOR 14: INPUT "", fil$: COLOR 7
chk$ = fdrv$ + ":\" + fil$:
typ$ = UCASE$(RIGHT$(fil$, 3))
IF typ$ <> "ZIP" THEN
   LOCATE c% - 1, 15: COLOR 12: PRINT "file-type must be ZIP!": COLOR 7
   LOCATE c%, 1: PRINT SPACE$(79)
   GOTO badtry
END IF

110 OPEN "I", #1, chk$: CLOSE #1

END SUB

SUB readerrorfile

CLS
PRINT : PRINT "IF ANY ERRORS were reported during this run testing "; UCASE$(fil$); " then there is "
PRINT "need for the file to be throughly tested before being passed to further "
PRINT "FREECEN processing."

PRINT : PRINT " The Error Reports (.ERC and .ERD) have been saved to the floppy disk "
PRINT "and may be inspected using NotePad."
COLOR 12: PRINT "  DO NOT ALTER OR DELETE these reports!": COLOR 7

PRINT : PRINT "If you are sufficiently competent and confident, you can perform the"
PRINT "corrections yourself."
COLOR 12: PRINT "If you have any doubts whatever -"; : COLOR 7: PRINT " please arrange for someone else to make"
PRINT "the necessary corrections"



noread = 0
COLOR 7:  PRINT "Do you wish to examine the error files now?  (Y/N)"; : peek$ = UCASE$(INPUT$(1))
IF peek$ <> "Y" THEN noread = 1

END SUB

SUB Warning

COLOR 12
LOCATE 6, 10: PRINT " WARNING: Always work on copies of your data files with these "
LOCATE 7, 10: PRINT " programmes and keep copies of the originals safe.            "
LOCATE 8, 10: PRINT " We do not wish to hazard many hours of painstaking work.     "

END SUB

